<?php
namespace Controllers; 

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification; 

class Ger80200ApuracaoEstoqueController extends \Teknisa\Libs\Controller\CRUD{
    
    protected $dataSourceName = "impostorop";
    protected $connection;
    
    public function __construct($crudService, $environment, $connection) {
        $this->connection = $connection;
        parent::__construct($crudService, $environment);
    }
    
    public function salvaImposto(DTO\Request $request, DTO\Response $response){
        
        $dataset = $request->getParameter("dataSet");
        if($$maoObraExterna["__is_new"] = false){
            $this->crudService->delete($this->dataSourceName, $rowToSave);
            $$maoObraExterna["__is_new"] = true;
        }
        $this->crudService->save($this->dataSourceName, $rowToSave);
    }
     
    public function excluiExcecaoProduto(DTO\Request $request, DTO\Response $response ){
        
        $rows     = $request->getParameter("Dataset")[0];
        $tipo     = $request->getParameter("Dataset")[1];
        $erroList = array();
        $deleted = array();
        
        try{
            forEach($rows as $row){
                $params =  array(
                    'P_CDFILIAL' => $row['CDFILIAL'],
                    'P_CDARVPROD' => $row['CDARVPROD'],
                    'P_TIPO' => $tipo
                );
                
                $stmt = $this->connection->prepare("
                        SELECT P.CDARVPROD, P.NMPRODUTO, 'NIVELANT' AS TIPO, PR.IDTPPRODUTOROP, PR.CDPRODUTO
                          FROM PRODUTOROP PR,PRODUTO P
                         WHERE PR.CDPRODUTO = P.CDPRODUTO 
                           AND PR.CDFILIAL = :P_CDFILIAL
                           AND PR.IDTPPRODUTOROP IN ('DE','MO','CO')
                           AND P.CDARVPROD LIKE :P_CDARVPROD||'%'
                           AND PR.IDTPPRODUTOROP <> :P_TIPO");
                $stmt->execute($params);
                $retorno = $stmt->fetchAll();
                // verifica se retornou
                if($retorno){
                    array_push($erroList, array('CDARVPROD' => $retorno[0]['CDARVPROD'],
                                                'NMPRODUTO' => $retorno[0]['NMPRODUTO'],
                                                'IDTPPRODUTOROP' => $retorno[0]['IDTPPRODUTOROP']));
                    
                    
                    
                    //"- O produto  ".$retorno[0]['CDARVPROD']. " - ".$retorno[0]['NMPRODUTO']." já cadastrado como ".$item.".");
                }else{
                    $paramsDelete = array(
                        'P_CDFILIAL' => $row['CDFILIAL'],
                        'P_CDPRODUTO' => $row['CDPRODUTO'],
                        'P_TIPO' => $row['IDTPPRODUTOROP']
                    );
                    $stmtDelete = $this->connection->prepare("
                        DELETE FROM PRODUTOROP 
                              WHERE CDFILIAL = :P_CDFILIAL
                                AND CDPRODUTO = :P_CDPRODUTO
                                AND IDTPPRODUTOROP = :P_TIPO
                    ");
                    $stmtDelete->execute($paramsDelete);
                    array_push($deleted, $paramsDelete);
                }
            }
        }catch(\Exception $ex){
            $response->setError(new Error("FALHA_PROC_DADOS " . $ex->getMessage(), 500));
        }
        
        if(!empty($erroList)){
            $response->addDataSet(new DataSet("errorList", $erroList));
            $response->addDataSet(new DataSet("deleted", $deleted));
            $response->setError(new Error("VERIFLOG", 500));
        }
    }
    
    
    public function excluiNivelProduto(DTO\Request $request, DTO\Response $response ){
        
        $rows           = $request->getParameter("Dataset")[0];
        $tipo_nivel     = $request->getParameter("Dataset")[1];
        $tipo_excecao   = $request->getParameter("Dataset")[2];
        $nrorg          = $this->crudService->getEnvironment()->getNrOrg();
        
        try{
            forEach($rows as $row){
                
                //delete nivel produto e as excecoes a ele relacionadas
                $params = array(
                    'P_CDFILIAL' => $row['CDFILIAL'],
                    'P_CDPRODUTO' => $row['CDPRODUTO'],
                    'P_TIPONIVEL' => $tipo_nivel,
                    'P_TIPOEXCECAO' => $tipo_excecao,
                    "P_NRORG" => $nrorg
                );
                $stmt = $this->connection->prepare("
                    DELETE FROM PRODUTOROP PDR
                      WHERE PDR.CDFILIAL = :P_CDFILIAL
                        AND PDR.NRORG = :P_NRORG
                        AND ((PDR.CDPRODUTO IN (SELECT PR.CDPRODUTO
                                              FROM PRODUTOROP PR, PRODUTO P, PRODUTO B
                                             WHERE P.CDPRODUTO = :P_CDPRODUTO
                                               AND B.CDARVPROD LIKE P.CDARVPROD||'%'
                                               AND PR.CDPRODUTO = B.CDPRODUTO
                                               AND PR.IDTPPRODUTOROP = :P_TIPOEXCECAO
                                               AND PR.CDFILIAL = :P_CDFILIAL) 
                                    AND PDR.IDTPPRODUTOROP = :P_TIPOEXCECAO ) 
                             OR (CDPRODUTO = :P_CDPRODUTO
                                    AND PDR.IDTPPRODUTOROP = :P_TIPONIVEL))
                ");
                
                $stmt->execute($params);
                
            }
        }catch(\Exception $ex){
            $response->setError(new Error("FALHA_PROC_DADOS " . $ex->getMessage(), 500));
        }

    }
    
}